#include <stdio.h>
#include <stdlib.h>

/* This code is Copyright INMOS. */

double strtod(const char *nptr, char **endptr)
{
  double d;
  int nchars, res;

  /* Here I rely on scanf to set errno to ERANGE if the converted value is */
  /* too big or too small.                                                 */
  res = sscanf(nptr, "%lf%n", &d, &nchars);

  /* If the conversion failed that must be because there were no digits at */
  /* all in the input.                                                     */
  if (res==EOF || res<1)
  {   
    if (endptr!=NULL) 
      *endptr = (char *)nptr;
    /* the cast is needed in prev. line.  See May 86 ANSI draft 3.2.2.4 */
    return 0.0;
  }
  if (endptr!=NULL) 
    *endptr = (char *)nptr + nchars;
  return d;
}

